opcode_count = {}

function count()
	local pc = memory.getregister("pc")
	local opcode = memory.readbyte(pc)
	opcode_count[opcode+1] = opcode_count[opcode+1] + 1
end

function save_count()
	for i=1,256 do
		l = string.format("%02X: %d\n",(i-1),opcode_count[i])
		emu.print(l)
	end
end

memory.registerexec(0x0000,0x10000,count)
emu.registerexit(save_count)

for i=1,256 do
	opcode_count[i] = 0
end

while (true) do
	emu.frameadvance()
end
